cbuffer Variables
{
	matrix WVPMatrix		: WorldViewProjection;
	matrix WorldMatrix		: World;
	matrix WorldITMatrix	: WorldInverseTranspose;
	matrix ViewITMatrix		: ViewInverseTranspose;
}

extern Texture2D DiffuseTexture;
extern Texture2D NormalMapTexture;
extern Texture2D HeightMapTexture;

SamplerState samLinear
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};

struct VS_INPUT
{
	float4 Pos		: POSITION;
	float3 Normal	: NORMAL;
	float3 Tangent	: TANGENT;
	float3 Binormal : BINORMAL;
	float2 Tex		: TEXCOORD;
};

struct PS_INPUT
{
	float4 Pos			: SV_POSITION;
	float2 Tex			: TEXCOORD0;
	float3 ToView		: TEXCOORD1;
	float3 WorldPos		: TEXCOORD2;
	float3x3 WorldToTangentSpace : TEXCOORD3;
	float3 SurfaceNormal : NORMAL;
};

//--------------------------------------------------------------------------------------
// Global variables
//--------------------------------------------------------------------------------------
float3 g_vMaterialAmbient   = float3( 1.0f, 1.0f, 1.0f );   // Material's ambient color
float3 g_vMaterialDiffuse   = float3( 1.0f, 1.0f, 1.0f );   // Material's diffuse color
float3 g_vMaterialSpecular  = float3( 1.0f, 1.0f, 1.0f );   // Material's specular color
float  g_fMaterialAlpha     = 1.0f;
float  g_nMaterialShininess = 32.0f;