#include "globals.fxh"

float3 EyeFromViewIT(){
	return float3(ViewITMatrix[0].w,ViewITMatrix[1].w,ViewITMatrix[2].w);
}

PS_INPUT VS( VS_INPUT vsInput )
{
	PS_INPUT psInput;
	
	// transform vertex pos to homogeneous coordinates
    psInput.Pos = mul( vsInput.Pos, WVPMatrix );
	
	// pass texture coords
	psInput.Tex = vsInput.Tex;
	
	return psInput;
}

///////////////////////////////////////////////
// Pixel Shader
///////////////////////////////////////////////
float4 PS(PS_INPUT psInput) : SV_Target
{
	float4 baseColor = DiffuseTexture.Sample( samLinear, psInput.Tex );
	return baseColor;
}

// Define the technique
technique10 Render
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, PS() ) );
    }
}
